--- old/usr/src/lib/libproc/common/Psymtab_machelf32.c	2015-01-19 19:54:47.306815438 -0500
+++ new/usr/src/lib/libproc/common/Psymtab_machelf32.c	2015-01-19 19:54:47.335806683 -0500
@@ -249,7 +249,7 @@
 	int dynstr_shndx;
 	Ehdr *ep;
 	Shdr *sp;
-	Dyn *dp;
+	Dyn *dp = NULL;
 	Dyn *d[DI_NENT] = { 0 };
 	uint_t i;
 	Off off;
@@ -366,6 +366,11 @@
 		hnchains = hash[1];
 	}
 
+	if ((d[DI_HASH] == NULL) || (hnbuckets == 0) || (hnchains == 0)) {
+		dprintf("empty or missing .hash\n");
+		goto bad;
+	}
+
 	/*
 	 * .dynsym and .SUNW_ldynsym sections.
 	 *
